<template>
  <q-page class="flex justify-center">

    <transition appear enter-active-class="animated fadeIn">

      <!-- Point-of-Sale Input -->
      <template v-if="!pendingPayment.status">
        <q-form @submit="setTerminalAmount" style="flex-basis: 100%;">

          <div class="column" style="height:100%">
            <div class="flex col-grow items-center justify-center bg-dark" style="max-height:15em;">
              <div class="row text-center items-center">
                <div class="text-amount text-white">{{ currencySymbol }}{{ paymentRequest.amount || '0' }}</div>
                <small class="text-currency text-muted q-pl-md text-end">{{ userCurrency }}</small>
              </div>
            </div>

            <div class="flex col-grow items-center justify-center">
              <div class="row numpad">
                <p class="col-12 text-center text-weight-bold">Enter the amount that is due</p>
                <q-btn v-for="button of buttons" :key="button" @click="onNumpadInput(button)" class="col-4 button" :label="button" flat />
              </div>
            </div>
            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn push label="Set Payment Amount" type="submit" color="primary" class="q-pa-md full-width" icon="forward" />
              </div>
            </div>
          </div>
        </q-form>
      </template>

      <!-- Waiting for Customer to scan QR Code -->
      <template v-else-if="pendingPayment.status === 'waiting'">
        <div style="flex-basis: 100%">
          <div class="column text-center" style="height: 100%; background:rgb(41 171 227);">

            <div class="flex col-shrink flex-center bg-dark">
              <div class="text-body1 text-white q-pa-lg">Instruct customer to scan the QR Code on the Bitcoin Cash Payment Terminal.</div>
            </div>

            <div class="flex col-grow items-end justify-center scan-qr-code-background">
              <q-btn label="Scan to Pay QR not working?" color="warning" class="q-mb-lg" @click="pendingPayment.status = 'waiting-fallback'" />
            </div>

            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn push label="Cancel Payment" color="dark" class="q-pa-md full-width" @click="onReturn" icon="cancel" />
              </div>
            </div>

          </div>
        </div>
      </template>

      <!-- Fallback to use BIP21 in case wallet does not support a Payment Protocol -->
      <template v-else-if="pendingPayment.status === 'waiting-fallback'">
        <div style="flex-basis: 100%">
          <div class="column text-center" style="height: 100%; background:rgb(41 171 227);">

            <div class="flex col-shrink flex-center bg-dark">
              <div class="text-body1 text-white q-pa-lg">Not all wallets support the "Scan to Pay" QR Code. Instead, have the customer scan the QR code shown below on your device.</div>
            </div>

            <div class="flex col-grow items-center justify-center">
              <BIP21Component :invoice="pendingPayment.invoice" @paymentReceived="paymentReceived" />
            </div>

            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn push label="Cancel Payment" color="dark" class="q-pa-md full-width" @click="onReturn" icon="cancel" />
              </div>
            </div>

          </div>
        </div>
      </template>

      <!-- Waiting for Customer to confirm payment -->
      <template v-else-if="pendingPayment.status === 'scanned'">
        <div style="flex-basis: 100%">
          <div class="column text-center" style="height: 100%; background:rgb(1 155 163);">

            <div class="flex col-shrink flex-center bg-dark">
              <div class="text-body1 text-white q-pa-lg">Waiting for Customer to confirm payment of <strong>{{ currencySymbol }}{{ paymentRequest.amount }}</strong> <small class="text-muted">{{ userCurrency }}</small>.</div>
            </div>
            <div class="flex col-grow items-end justify-center">
              <img src="~assets/confirm-payment.webp" style="max-width:100%; max-height:500px;" />
            </div>
            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn push label="Cancel Payment" color="dark" class="q-pa-md full-width" @click="onReturn" icon="cancel" />
              </div>
            </div>

          </div>
        </div>
      </template>

      <!-- Paid -->
      <template v-else-if="pendingPayment.status === 'paid'">
        <div style="flex-basis: 100%">

          <div class="column text-center bg-positive" style="height: 100%">
            <div class="flex col-shrink flex-center bg-dark">
              <div class="text-body1 text-white q-pa-lg">Payment of {{ currencySymbol }}{{ paymentRequest.amount }} <small class="text-muted">{{ userCurrency }}</small> received successfully.</div>
            </div>
            <div class="flex col-grow items-center justify-center">
              <q-icon name="check_circle" size="20em" color="white" />
            </div>
            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn label="Done" color="dark" class="full-width q-pa-md" @click="onReturn" icon="check" square />
              </div>
            </div>
          </div>

        </div>
      </template>

    </transition>
  </q-page>
</template>

<script setup lang="ts">
//-----------------------------------------------------------------------------
// Imports and Framework features
//-----------------------------------------------------------------------------

import { reactive, onMounted, computed } from 'vue'
import { useRoute } from 'vue-router'
import { useQuasar } from 'quasar'
import { useTerminalStore } from '../../stores/terminal-store'
import { storeToRefs } from 'pinia'
import { getCurrencySymbol } from '../../lib/utils'

import BIP21Component from '../../components/BIP21Component.vue'

import type { Settings, PendingPayment, PaymentRequest } from '../../interfaces'

import axios from 'axios'
import CashPay from '@developers.cash/cash-pay-server-js'

const $q = useQuasar()
const $route = useRoute()
const terminalStore = useTerminalStore()

//-----------------------------------------------------------------------------
// Constants and Properties
//-----------------------------------------------------------------------------

const terminalId = $route.params.terminalId
const terminalPassword = $route.params.terminalPassword
const buttons = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '0', '⌫']

const pendingPayment = reactive<PendingPayment>({
  status: undefined,
  invoice: undefined
})

const paymentRequest = reactive<PaymentRequest>({
  amount: ''
})

const userCurrency = computed(() => {
  return terminalStore.settings?.currency
})

const currencySymbol = computed(() => {
  const symbol = getCurrencySymbol(userCurrency.value)
  return symbol.length > 1 ? symbol + ' ' : symbol
})

//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

function onNumpadInput (key: string): void {
  // If the backspace character is clicked...
  if (key === '⌫') {
    paymentRequest.amount = paymentRequest.amount.substring(0, paymentRequest.amount.length - 1)
  } else {
    if (key === '.') { // Dont allow multiple decimals and prefix first '.' with '0'
      if (paymentRequest.amount.includes('.')) return
      if (!paymentRequest.amount.length) paymentRequest.amount = '0'
    }
    paymentRequest.amount = `${paymentRequest.amount.toString()}${key}`
  }
}

function onReturn (): void {
  paymentRequest.amount = ''
  pendingPayment.status = undefined
  pendingPayment.invoice = undefined
}

async function setTerminalAmount (): Promise<void> {
  try {
    if (isNaN(parseFloat(paymentRequest.amount))) {
      throw new Error('Amount given is not a valid number')
    }

    $q.loading.show()

    // Create an invoice.
    const createInvoiceRes = await axios.post(`${process.env.API_URL}/terminal/${terminalId}/${terminalPassword}/create-invoice`, {
      amount: Number(paymentRequest.amount)
    })

    pendingPayment.invoice = createInvoiceRes.data

    /* eslint-disable */
    const invoice = new CashPay.Invoice()
      .on('requested', invoiceScanned)
      .on('broadcasted', paymentReceived)
    await invoice.createFromExisting(pendingPayment.invoice)

    pendingPayment.status = 'waiting'
  } catch (err: any) {
    $q.notify({ message: err.message })
  } finally {
    $q.loading.hide()
  }
}

async function invoiceScanned () {
  pendingPayment.status = 'scanned'
}

async function paymentReceived () {
  pendingPayment.status = 'paid'

  const receivedSound = new Audio('/sounds/received.ogg');
  receivedSound.play();
}
</script>

<style lang="scss">
  .text-amount {
    font-size: 4em;
    font-weight: bold;
  }

  .text-currency {
    font-size: 2em;
    font-weight: bold;
  }

  .numpad {
    max-width: 100%;
    display: flex;
    border-radius: 10px;
  }

  .button {
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 2em;
  }

  .scan-qr-code-background {
    background:url('../../assets/scan-qr-code.webp');
    background-position:center bottom;
    background-repeat: no-repeat;
    background-size: contain;
  }
</style>
